#define IMMAGINE "clone.img"
#define LOW 746
#define HIGH 2880

#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <dos.h>


int CreaImg(void);
int CloneFromImg(void);
int CheckImg(void);
int CheckDisk(void); //controlla se il floppy inserito  da 720 o da 1.44
int ReadSector(void);
int WriteSector(int type);

int main(void)
{
  char buf[512];
  char scelta;
  int floppy;
  _setcursortype(_NOCURSOR);
 do
 {
  clrscr();
  printf("\n            -----======< Clone Floppy 1.1 >=====-----");
  printf("\n                                By                   ");
  printf("\n                            Lonely Wolf              ");
// (ultimo aggiornamento: 04/09/2K2 h 01:10)
  printf("\n ------------------------------------------------------------------------------");
  printf("\n 1 - Crea Immagine Floppy");
  printf("\n 2 - Clona Floppy da Immagine\n");
  printf("\n 3 - Clona Floppy Direttamente");
  printf("\n 4 - Esci ");
//  printf("\n 5 debug mode");
  printf("\n ------------------------------------------------------------------------------");
  printf("\n Scelta #: ");
  scelta = getche();

  switch(scelta)
  {
		case '1':
					clrscr();
					CreaImg();
					break;
		case '2':
					CloneFromImg();
					break;

		case '3':
					clrscr();
					floppy=ReadSector();
					WriteSector(floppy);
					break;

		case '4':   ;
  }
 }while(scelta != '4');

  return 0;
}

//-------------------- Functions ----------------------------\\
int CheckDisk(void)
{
  char type[512];
  int media;
  if(absread(0, 1, 0, &type) != 0)
  {
		perror("\n Impossibile leggere dal floppy");
		exit(1);
  }
  if(type[21] == '')
  {
		media = LOW;
		return media;
  }
  else if(type[21] == '')  //Qui impostiamo il numero di sect
  {								//che devono essere letti a seconda
		media = HIGH;		   //del floppy inserito
		return media;
  }
	//printf("\n tipo = %x",type[21]);
	return 1;
}

int ReadSector(void)
{
  FILE *in;
  int mediactrlR, sectornolimits;
  char buffer[512];
//  printf("\n readsector");
  printf("\n Inserire Floppy Originale nel Drive A: e premere un tasto per continuare...");
  getch();
  mediactrlR = CheckDisk();
  for (int l=0; l<512;l++)
	 buffer[l]=0; //azzeriamo buffer, non si sa mai
  if ((in = fopen(IMMAGINE, "wb")) == NULL)
  {
	 printf("\n Impossibile Creare il File");
	 return 1;
	}
  clrscr();
  printf("\n\n\n\n\n Clonazione Floppy...[Lettura Settori Originali]\n\n\n");
  delay(2000);
  for(sectornolimits = 0; sectornolimits <CheckDisk(); sectornolimits++)
  {
		if (absread(0, 1, sectornolimits, &buffer) != 0)
		{
			perror("\n Impossibile leggere dal floppy");
			return 1;
		}

		for (int m=0; m<512;m++)
			printf("%c",buffer[m]);

		fwrite(&buffer,sizeof(buffer),1,in);
  }
  fclose(in);
//  printf("\n Terminata ReadSector");
  return mediactrlR; //serve per controllare che il disco inserito successiva
  //mente per terminare la clonazione sia dello stesso tipo dell'originale,
  //altrimenti non va bene
}

int WriteSector(int type)
{
  FILE *in;
  int mediactrlW,sectornolimits;
  char bufff[512];
//  printf("\n Write");
  printf("\n Inserire Nuovo Floppy nel Drive A: e premere un tasto per continuare...");
  getch();

  mediactrlW = CheckDisk(); //stessa solfa e confronta floppy inseriti
  //printf("\n Mediactl %d",mediactrlW);
  if ((in = fopen(IMMAGINE, "rb")) == NULL)//si prepara a leggere da immagine
  {
	 printf("\n Impossibile Creare il File");
	 return 1;
  }
//  printf(" %d",type);
  if(mediactrlW != type)  //ha inserito il floppy corretto?
  {
		printf("\n ERRORE! Hai inserito un Floppy di capacit diversa!!");
		fclose(in);
		getch();
		return 1; //esce dal programma di prepotenza :)
  }
  clrscr();
  printf("\n\n\n\n\n Clonazione Floppy...[Scrittura Settori Clonati]\n\n\n");
  delay(2000);
  for(sectornolimits = 0; sectornolimits <CheckDisk(); sectornolimits++)
  {
		fread(&bufff,sizeof(bufff),1,in);
		//printf("\n Voi siete qui: %ld",ftell(in)); era per la modalit debug ;)
		if (abswrite(0, 1, sectornolimits, &bufff) != 0)
		{
			perror("\n Impossibile scrivere sul floppy");
			return 1;
		}
		//madonna quanto ci mette per i floppy da 1.44!

		for(int m=0; m<512;m++)
			 printf("%c",bufff[m]);
  }
  fclose(in);
  clrscr();
  printf("\n\n\n\n\n\n\n\n\n\n               Clonazione Terminata! ;) ");
  //avrei potuto usare gotoxy...mi andava cos :)
  getch();
  return 0;
}
int CreaImg(void)
{
  FILE *in;
  int mediactrlR, sectornolimits;
  char buff[512];
//  printf("\n Crea IMg");
  printf("\n Inserire Floppy nel Drive A: e premere un tasto per continuare...");
  getch();
  for (int l=0; l<512;l++)
	 buff[l]=0;
  if ((in = fopen(IMMAGINE, "wb")) == NULL)
  {
	 printf("\n Impossibile Creare il File");
	 return 1;
	}
  clrscr();
  printf("\n\n\n\n\n Creazione Immagine in Corso...\n\n\n");
  delay(2000);
  for(sectornolimits = 0; sectornolimits <CheckDisk(); sectornolimits++)
  {
		if (absread(0, 1, sectornolimits, &buff) != 0)
		{
			perror("\n Impossibile leggere dal floppy");
			return 1;
		}

		for (int m=0; m<512;m++)
			printf("%c",buff[m]);

		fwrite(&buff,sizeof(buff),1,in);
  }
  delay(4000);
  clrscr();
  printf("\n Finito! L'Immagine  nella directory di questo programma");
  //Wolf ricorda di implementare in una successiva versione la possibilit
  //di piazzare sto file dove gli pare all'utente...mi sembra giusto
  fclose(in);
  getch();
  return 0;
}

int CloneFromImg(void)
{
	//per questa funzione non posso usare la stessa forma di ctrl del tipo
	//floppy perch per sapere l'immagine a che tipo di floppy appartiene
	//non confronto + 2 dischetti direttamente ma col contenuto di un file.
	//devo fargliela leggere dal file e confrontarla col disco inserito,
	//ecco, in pratica devo modificare la CheckDisk()
	//per pensandoci bene...potevo continuare a usare la checkdisk passandogli
	//un parametro...ora mi fa fatica, altro giro altra corsa :) che matto eheh
  FILE *in;
  int sectornolimits;
  char buf[512];
  printf("\n Inserire Nuovo Floppy nel Drive A: e premere un tasto per continuare...");
  getch();
  //floppyctrl = CheckDisk(); //ctrl floppy
  //imgctrl = CheckImg();	//ctrl floppy da file immagine
 if(CheckDisk() != CheckImg()) //se son diversi ...
 {
		printf("\n ERRORE! Hai inserito un floppy di capacit diversa da quella dell'immagine.");
		getch();
		return 1;
 }

  if ((in = fopen(IMMAGINE, "rb")) == NULL)
  {
	 printf("\n Impossibile Creare il File");
	 return 1;
  }
  clrscr();
  printf("\n\n\n\n\n Clonazione Floppy...[Scrittura Settori Clonati]");
  delay(2000);
  for(sectornolimits = 0; sectornolimits <CheckDisk(); sectornolimits++)
  {
		fread(&buf,sizeof(buf),1,in);
		//printf("\n Voi siete qui: %ld",ftell(in)); era per la modalit debug ;)
		if (abswrite(0, 1, sectornolimits, &buf) != 0)
		{
			perror("\n Impossibile scrivere sul floppy");
			return 1;
		}

		for(int m=0; m<512;m++)
			 printf("%c",buf[m]);
  }
  fclose(in);
  delay(2000);
  clrscr();
  printf("\n\n\n\n\n\n\n\n\n\n               Clonazione Terminata! ;) ");
  //avrei potuto usare gotoxy...mi andava cos :)
  getch();
  return 0;
}

int CheckImg(void)
{
  FILE *img;
  char typeimg[512];
  int media;

  if ((img = fopen(IMMAGINE, "rb")) == NULL)
  {
	 printf("\n Impossibile leggere dal File");
	 getch();
	 return 1;
  }
  fread(&typeimg,sizeof(typeimg),1,img);


  if(typeimg[21] == '')
  {
 //		printf("IMG1 %c",typeimg[21]);
		media = LOW;
		fclose(img);
		return media; //ritorna tipo floppy dell'immagine, il
		//ctrl lo fa fuori cmp con il risultato di checkdisk
  }
  if(typeimg[21] == '')
  {									 //Qui impostiamo il numero di sect
								//che devono essere letti a seconda
		media = HIGH;		   //del floppy inserito

	//	printf("IMG2 %c",typeimg[21]);
		fclose(img);
		return media;
  }
	fclose(img);
	getch();
	return 1;
}